(function(FuseBox){FuseBox.$fuse$=FuseBox;
FuseBox.target = "server";
FuseBox.pkg("default", {}, function(___scope___){
___scope___.file("index.js", function(exports, require, module, __filename, __dirname){

"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fuse_box_1 = require("fuse-box");
var yargs_1 = require("yargs");
var ng_compiler_plugin_1 = require("./tools/plugins/ng.compiler.plugin");
var ng_polyfill_plugin_1 = require("./tools/plugins/ng.polyfill.plugin");
var ng_prod_plugin_1 = require("./tools/plugins/ng.prod.plugin");
var ng_optimizer_plugin_1 = require("./tools/plugins/ng.optimizer.plugin");
var ng_server_module_plugin_1 = require("./tools/plugins/ng.server.module.plugin");
var ng_bootstrap_plugin_1 = require("./tools/plugins/ng.bootstrap.plugin");
var DEFAULT_CONFIG = {
    enableAotCompilaton: yargs_1.argv.aot,
    productionBuild: yargs_1.argv.prod,
    supportIE11: true,
    supportIE11Animations: false,
    enableAngularAnimations: false,
    enableAngularForms: false,
    enableServiceWorker: false,
    serverPort: process.env.PORT && +process.env.PORT || 5000,
    angularServerModule: {
        moduleName: 'AppServerModule',
        modulePath: 'src/server/server.angular.module'
    }
};
exports.fusingAngular = function (opts) {
    var settings = __assign({}, DEFAULT_CONFIG, opts);
    return {
        run: function () {
            var fuseBrowser = fuse_box_1.FuseBox.init({
                homeDir: "./",
                output: "./.dist/public/js/$name.js",
                target: 'browser@es5',
                cache: !settings.productionBuild,
                plugins: [
                    ng_bootstrap_plugin_1.NgBootstrapPlugin({ enabled: settings.enableAotCompilaton }),
                    ng_prod_plugin_1.NgProdPlugin({ enabled: settings.productionBuild }),
                    ng_polyfill_plugin_1.NgPolyfillPlugin(),
                    ng_compiler_plugin_1.NgCompilerPlugin({ enabled: settings.enableAotCompilaton }),
                    ng_optimizer_plugin_1.NgOptimizerPlugin({ enabled: settings.enableAngularBuildOptimizer }),
                    settings.productionBuild && fuse_box_1.QuantumPlugin({
                        bakeApiIntoBundle: 'vendor',
                        warnings: false,
                        uglify: true,
                        treeshake: true,
                        ensureES5: true
                    })
                ]
            });
            var mainAppEntry = 'app.browser.module.ts';
            var fuseServer = fuse_box_1.FuseBox.init({
                target: 'server@es5',
                homeDir: "./",
                output: "./.dist/$name.js",
                cache: !settings.productionBuild,
                plugins: [
                    fuse_box_1.EnvPlugin({ serverPort: settings.serverPort }),
                    ng_prod_plugin_1.NgProdPlugin({ enabled: settings.productionBuild, fileTest: 'server.angular.module' }),
                    settings.angularServerModule && ng_server_module_plugin_1.NgServerModulePlugin({
                        module: settings.angularServerModule.moduleName,
                        path: settings.angularServerModule.modulePath
                    }),
                    ng_polyfill_plugin_1.NgPolyfillPlugin({ isServer: true, fileTest: 'server.angular.module' })
                ]
            });
            var vendorBundle = fuseBrowser.bundle('vendor');
            var appBundle = fuseBrowser.bundle('app');
            var serverBundle = fuseServer.bundle("server");
            vendorBundle.instructions(" ~ src/browser/" + mainAppEntry);
            appBundle.instructions(" !> [src/browser/" + mainAppEntry + "]");
            serverBundle
                .instructions(" > [src/server/server.ts]")
                .completed(function (proc) { return proc.start(); });
            if (!settings.productionBuild) {
                appBundle.watch('src/**');
                serverBundle.watch("src/**");
                fuseServer.dev({
                    root: './.dist',
                    port: settings.serverPort,
                    httpServer: false
                });
            }
            fuseBrowser.run();
            fuseServer.run();
        }
    };
};
var app = exports.fusingAngular({
    productionBuild: true,
    enableAotCompilaton: true
});
app.run();
//# sourceMappingURL=index.js.map
});
___scope___.file("tools/plugins/ng.compiler.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var main_1 = require("@angular/compiler-cli/src/main");
var path_1 = require("path");
var defaults = {};
var NgcPluginClass = /** @class */ (function () {
    function NgcPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
    }
    NgcPluginClass.prototype.bundleStart = function () {
        this.opts.enabled && main_1.main(['-p', path_1.resolve('tsconfig.aot.json')]);
    };
    return NgcPluginClass;
}());
exports.NgcPluginClass = NgcPluginClass;
exports.NgCompilerPlugin = function (options) { return new NgcPluginClass(options); };
//# sourceMappingURL=ng.compiler.plugin.js.map
});
___scope___.file("tools/plugins/ng.polyfill.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defaults = {};
exports.NG_POLY_BASE = [
    'core-js/es7/reflect'
];
exports.NG_POLY_SERVER = exports.NG_POLY_BASE.concat([
    'zone.js/dist/zone-node',
    'zone.js/dist/long-stack-trace-zone'
]);
exports.NG_POLY_BROWSER = exports.NG_POLY_BASE.concat([
    'zone.js/dist/zone'
]);
exports.NG_POLY_BROWSER_IE_ANIMATIONS = [
    'web-animations-js'
];
exports.NG_POLY_BROWSER_IE = [
    'core-js/es6/symbol',
    'core-js/es6/object',
    'core-js/es6/function',
    'core-js/es6/parse-int',
    'core-js/es6/parse-float',
    'core-js/es6/number',
    'core-js/es6/math',
    'core-js/es6/string',
    'core-js/es6/date',
    'core-js/es6/array',
    'core-js/es6/regexp',
    'core-js/es6/map',
    'core-js/es6/weak-map',
    'core-js/es6/set'
];
var prepForTransform = function (deps) {
    return deps.map(function (dep) {
        return "import '" + dep + "'";
    }).join('\n');
};
var NgPolyfillPluginClass = /** @class */ (function () {
    function NgPolyfillPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = this.opts.fileTest &&
            new RegExp(this.opts.fileTest) || /(app.browser.module.ts)/;
    }
    NgPolyfillPluginClass.prototype.onTypescriptTransform = function (file) {
        if (!this.test.test(file.relativePath))
            return;
        file.contents = prepForTransform(this.buildSet()) + "\n" + file.contents;
    };
    NgPolyfillPluginClass.prototype.buildSet = function () {
        if (this.opts.isServer) {
            return exports.NG_POLY_SERVER;
        }
        else {
            return exports.NG_POLY_BROWSER;
        }
    };
    return NgPolyfillPluginClass;
}());
exports.NgPolyfillPluginClass = NgPolyfillPluginClass;
exports.NgPolyfillPlugin = function (options) { return new NgPolyfillPluginClass(options); };
//# sourceMappingURL=ng.polyfill.plugin.js.map
});
___scope___.file("tools/plugins/ng.prod.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var defaults = {
    enabled: true
};
var NgProdPluginClass = /** @class */ (function () {
    function NgProdPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = this.regex || /(app.browser.module.ts)/;
        this.opts = __assign({}, defaults, opts);
    }
    Object.defineProperty(NgProdPluginClass.prototype, "regex", {
        get: function () {
            return this.opts &&
                this.opts.fileTest &&
                new RegExp(this.opts.fileTest) || undefined;
        },
        enumerable: true,
        configurable: true
    });
    NgProdPluginClass.prototype.onTypescriptTransform = function (file) {
        if (!this.opts.enabled || !this.test.test(file.relativePath))
            return;
        file.contents = "import { enableProdMode } from '@angular/core';\n    enableProdMode()\n    " + file.contents;
    };
    return NgProdPluginClass;
}());
exports.NgProdPluginClass = NgProdPluginClass;
exports.NgProdPlugin = function (options) { return new NgProdPluginClass(options); };
//# sourceMappingURL=ng.prod.plugin.js.map
});
___scope___.file("tools/plugins/ng.optimizer.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var build_optimizer_1 = require("@angular-devkit/build-optimizer");
var defaults = {};
var NgOptimizerPluginClass = /** @class */ (function () {
    function NgOptimizerPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = /.js/;
    }
    NgOptimizerPluginClass.prototype.transform = function (file) {
        if (!this.opts.enabled)
            return;
        var transpiledContent = build_optimizer_1.buildOptimizer({
            content: file.contents,
            isSideEffectFree: true
        }).content;
        if (transpiledContent) {
            file.contents = transpiledContent;
        }
    };
    return NgOptimizerPluginClass;
}());
exports.NgOptimizerPluginClass = NgOptimizerPluginClass;
exports.NgOptimizerPlugin = function (options) {
    return new NgOptimizerPluginClass(options);
};
//# sourceMappingURL=ng.optimizer.plugin.js.map
});
___scope___.file("tools/plugins/ng.server.module.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NgServerModulePluginClass = /** @class */ (function () {
    function NgServerModulePluginClass(opts) {
        this.opts = opts;
        this.test = /server.app.ts/;
    }
    NgServerModulePluginClass.prototype.onTypescriptTransform = function (file) {
        if (!file.relativePath.includes('server.app.ts'))
            return;
        var d = RegExp(/declare const AppServerModule: any/);
        var dotCountToAdd = file.relativePath.split('/').length - 1;
        var c = Array.from(Array(dotCountToAdd)).map(function (a) { return '..'; }).join('/');
        file.contents = file.contents.replace(d, "import { " + this.opts.module + " } from '" + c.concat('/') + this.opts.path + "'");
    };
    return NgServerModulePluginClass;
}());
exports.NgServerModulePluginClass = NgServerModulePluginClass;
exports.NgServerModulePlugin = function (options) {
    return new NgServerModulePluginClass(options);
};
//# sourceMappingURL=ng.server.module.plugin.js.map
});
___scope___.file("tools/plugins/ng.bootstrap.plugin.js", function(exports, require, module, __filename, __dirname){

"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defaults = {};
var NgBootstrapPluginClass = /** @class */ (function () {
    function NgBootstrapPluginClass(opts) {
        if (opts === void 0) { opts = defaults; }
        this.opts = opts;
        this.test = /app.browser.module.ts/;
    }
    NgBootstrapPluginClass.prototype.onTypescriptTransform = function (file) {
        if (this.opts.enabled && this.test.test(file.absPath) && file.context.bundle.name === 'app') {
            file.contents = file.contents.replace(/^.*platformBrowserDynamic.*/gm, '');
            file.contents =
                "\n        import { platformBrowser } from '@angular/platform-browser'\n        import { AppModuleNgFactory } from './.aot/src/browser/app.module.ngfactory.js'\n        platformBrowser().bootstrapModuleFactory(AppModuleNgFactory)\n        " + file.contents;
        }
    };
    return NgBootstrapPluginClass;
}());
exports.NgBootstrapPluginClass = NgBootstrapPluginClass;
exports.NgBootstrapPlugin = function (options) {
    return new NgBootstrapPluginClass(options);
};
//# sourceMappingURL=ng.bootstrap.plugin.js.map
});
return ___scope___.entry = "index.js";
});

FuseBox.import("default/index.js");
FuseBox.main("default/index.js");
})
(FuseBox)